\chapter{Computer Science or How to enslave computers}
\label{ch:Computer Science}
You wouldn't imagine how important is the right sequence of 0s and 1s: indeed even a computer program that can manipulate objects in \textit{millions} dimensions, test whether a \textit{one thousand}-digit number is prime or not, play (and win) chess against you, can be reduced at a mere sequence of bits, each of value 0 or 1.\\
However, despite their great computational power, even modern computer cannot solve \cite{NP_Complexity}: so software developers with the collaboration of mathematicians are always trying out new algorithms to speed things up at the cost of the same \cite{Space_And_Time_Resources}.

\section{Evaluation of powers}
\label{sec:Evaluation of powers}
Computer stacks and heaps are not infinite quantity (too  bad) so you wish to minimize the effort involved in computational tasks, in order to get higher performance. Let's assume you wish to calculate $x^n$, how do you go about?
\begin{itemize}
\item you could multiply $x$ $n-1$ times
\item you could \textit{cheat} and get the same result with about \textbf{half} of the operations
\end{itemize}
There are multiple ways to shorten your path to the result, but among all those, we'll examine only the two most popular:
\begin{itemize}
\item \textbf{Binary exponentiation}\\
	The algorithm is like this
	\begin{enumerate}
	\item write $n$ in binary
	\item replace each "1" with "s" and every "0" with "m"
	\item cross off the starting "sm"
	\item "s" $\to$ square, "m" $\to$ multiply by $x$
	\end{enumerate}
	Simpler but not always better is the following relationship
	$$x^n =
	\begin{cases}
	\left( (x^2)^{\frac{n}{2}} \right) \text{ if } n \text{ is even}\\
	\left( x \cdot (x^2) ^{\frac{n-1}{2}} \right) \text{ if } n \text{ is odd}
	\end{cases}$$
	which can help reduce the number of operations needed.
\item \textbf{Addition chains}\\
	Define $\langle \mathcal{A}_r \rangle$ as the sequence of powers of $x$
	$$\begin{cases}
	\mathcal{A}_0 = 1\\
	\mathcal{A}_1, \mathcal{A}_2, \mathcal{A}_3 \ldots \mathcal{A}_{r-1} \in \mathbb{N}_0
	\mathcal{A}_r = n\\
	\mathcal{A}_i = \mathcal{A}_j + \mathcal{A}_k \quad, k \le j < i
	\end{cases}$$
	If we find such a sequence for $n$ our job is done. However most of these addition 				chains/trees are very complicated and although they can simplify the job, are hard to 			find.
	Few properties should be noticed and underlined:
	\begin{itemize}
	\item $\mathcal{A}_1 = 2$
	\item $\text{Length}[\mathcal{A}_{m\cdot n}] \le \text{Length}[\mathcal{A}_{m} + \text{Length}[\mathcal{A}_{n}]$
	\item Let $\lambda(n) = \lfloor \hyperref[sec:A note on notations (cit.)]{\lg} n \rfloor, \upsilon (n)$ be the number of 1s in the binary notation of $n$. Then
	\begin{itemize}
	\item $\lambda(1) = 0$
	\item $\lambda(2n) = \lambda(2n+1) = \lambda(n)+1$
	\item $\upsilon(1) = 1$
	\item $\upsilon(2n) = \upsilon(n)$
	\item $\upsilon(2n+1) = \upsilon(n) + 1$
	\item $\text{Length}[\mathcal{A}_{n}] \le \upsilon(n) + \lambda(n) - 1$
	\end{itemize}
	\item $\text{Length}[\mathcal{A}_{n}] \ge \lceil \lg n \rceil$
	\item $\text{Length}[\mathcal{A}_{2^a}] = a$
	\item $\text{Length}[\mathcal{A}_{2^a + 2^b}] = a+1 \quad, a > b$
	\item $\text{Length}[\mathcal{A}_{2^a + 2^b + 2^c}] = a+2 \quad, a > b > c$
	\item $\text{Length}[\mathcal{A}_{2^a + 2^b + 2^c + 2^d}] = a+2 \quad, a > b > > d$
	\end{itemize}
	except a few \hyperref[sec:A note on notations (cit.)]{side-cases}, which should be trivially found by the reader.
\end{itemize}

\begin{figure}[ht!]
\centering
\includegraphics[width=90mm]{ch/cs/img/additions.png}
\caption{A tree of the shortest addition chains $\forall n < 149$}
\end{figure}

\section{Evaluation of polynomials}
\label{sec:Evaluation of polynomials}
Given the hypothesis of the last chapter, how should you behave when evaluating an entire polynomial?\\
Let $\upsilon (x) = \sum \limits_{k=0} ^n \upsilon _k \cdot x^k = \upsilon _n \cdot x^n + \upsilon _{n-1} \cdot x^{n-1} + \upsilon _{n-2} \cdot x^{n-2} + \ldots + \upsilon _1 \cdot x + \upsilon _0$ with $u_n \neq 0$, your task is to find a way to minimize multiplications and sums between terms to evaluate the polynomial at $x \in \mathbb{R}$.\\
Even \cite{Isaac_Newton_Wikipedia} solved this problem, yet \cite{Horner_Method_Wikipedia} is named after \cite{William_George_Horner_Wikipedia}:
$$\upsilon(x) = (((\ldots (\upsilon_n \cdot x + \upsilon_{n-1})x + \ldots ))) + \upsilon_0$$

\section{Langton's ant}
\label{sec:Langton's ant}
\cite{Christopher_Langton_Wikipedia}, following just two rules is able to move and create surprising patterns. If the ant is on a square colored
\begin{enumerate}
\item white $\to$ turns $90°$ right
\item black $\to$ turns $90°$ left
\end{enumerate}
flips the color of the square and moves forward one unit.
As you can see, the rules are very simple ones, so $\ldots$ where is the interesting thing? After about $10000$ steps, the ant will create almost-symmetrical landscapes and it will begin to create a diagonal highway. Much more: we can do whatever we want with these ants (many ants, obstacles $\ldots$, but all of them always end up doing the diagonal highway.
\begin{figure}[ht!]
\centering
\includegraphics[width=70mm]{ch/cs/img/ant.png}
\caption{The ant's highway appears after about $10000$ moves}
\end{figure}
Test it by downloading th \cite{Windows_Executable_Langton} or \cite{Source_Code}.